Index: code/branches/lastmanstanding2/data/levels/lastManStanding.oxw
===================================================================
--- code/branches/lastmanstanding2/data/levels/lastManStanding.oxw	(revision 7716)
+++ code/branches/lastmanstanding2/data/levels/lastManStanding.oxw	(revision 7899)
@@ -38,29 +38,23 @@
 
 <!-- ------------ middle asteroid -------------- -->
-    <StaticEntity position="0,20,0" collisionType=static>
-       <attached>
-           <Model position="0,0,0" scale=140 mesh="asteroid_UV.mesh" shadow=true />
-           <!-- ParticleEmitter position="0,0,0" source="Orxonox/Steam" / -->
-       </attached>
-      <collisionShapes>
-        <SphereCollisionShape radius="145" />
-      </collisionShapes>
+    <StaticEntity position="0,0,0" collisionType=static>    
+        <attached>
+            <MovableEntity position="0,20,0" rotationrate="-4.5" rotationaxis="0,1,0" >
+                <attached>
+                    <Model position="0,0,0" scale=140 mesh="asteroid_UV.mesh" shadow=true />
+                    <Model position="-160,40,28.4" scale=1 mesh="sphere.mesh" /><!--EasterEgg indicator-->
+                    <PickupSpawner position="-160,40,17" triggerDistance="20" respawnTime="5" maxSpawnedItems="15"><!--EasterEgg-->
+                        <pickup>
+                            <InvisiblePickup template=hugeinvisiblepickup />
+                        </pickup>
+                    </PickupSpawner>
+                </attached>
+            </MovableEntity>
+        </attached>
+        <collisionShapes>
+            <SphereCollisionShape radius="145" />
+        </collisionShapes>
     </StaticEntity>
 
-    <PickupSpawner position="-160,65,10" triggerDistance="10" respawnTime="5" maxSpawnedItems="10"><!--EasterEgg-->
-      <pickup>
-        <InvisiblePickup template=mediuminvisiblepickup />
-      </pickup>
-    </PickupSpawner>
-    <PickupSpawner position="-160,60,17" triggerDistance="10" respawnTime="5" maxSpawnedItems="10"><!--EasterEgg-->
-      <pickup>
-        <InvisiblePickup template=hugeinvisiblepickup />
-      </pickup>
-    </PickupSpawner>
-    <StaticEntity position="-160,60,28.4"><!--EasterEgg-Indicator-->
-      <attached>
-        <Model position="0,0,0" scale=1 mesh="sphere.mesh" />
-      </attached>
-    </StaticEntity>
 
 <!-- ---------------asteroid dome----------------- -->
@@ -138,5 +132,5 @@
 
 
-<?lua end ?>
+<?lua end ?><!-- ---------------asteroid dome END------------------->
 
   </Scene>
Index: code/branches/lastmanstanding2/data/overlays/lastManStandingHUD.oxo
===================================================================
--- code/branches/lastmanstanding2/data/overlays/lastManStandingHUD.oxo	(revision 7716)
+++ code/branches/lastmanstanding2/data/overlays/lastManStandingHUD.oxo	(revision 7899)
@@ -65,5 +65,5 @@
     />
 
-    <OverlayText
+    <!--OverlayText
      position  = "0.02, 0.07"
      pickpoint = "0.0, 0.0"
@@ -93,5 +93,5 @@
      align     = "left"
      caption   = "|"
-    />
+    /-->
 
   </OverlayGroup>
Index: code/branches/lastmanstanding2/data/overlays/lastTeamStandingHUD.oxo
===================================================================
--- code/branches/lastmanstanding2/data/overlays/lastTeamStandingHUD.oxo	(revision 7716)
+++ code/branches/lastmanstanding2/data/overlays/lastTeamStandingHUD.oxo	(revision 7899)
@@ -1,6 +1,6 @@
-<Template name="LastteamstandingHUD">
-  <OverlayGroup name="LastteamstandingHUD" scale = "1, 1">
+<Template name="lastTeamStandingHUD">
+  <OverlayGroup name="lastTeamStandingHUD" scale = "1, 1">
 
-<GametypeFadingMessage
+<GametypeFadingMessag
      name     = "fadingmessage"
      position = "0.5, 0.01"
@@ -55,34 +55,4 @@
     />
 
-    <OverlayText
-     position  = "0.02, 0.07"
-     pickpoint = "0.0, 0.0"
-     font      = "ShareTechMono"
-     textsize  = 0.04
-     colour    = "1.0, 1.0, 1.0, 1.0"
-     align     = "left"
-     caption   = "__________|"
-    />
-
-    <OverlayText
-     position  = "0.022, 0.07"
-     pickpoint = "0.0, 0.0"
-     font      = "ShareTechMono"
-     textsize  = 0.04
-     colour    = "1.0, 1.0, 1.0, 1.0"
-     align     = "left"
-     caption   = "__________"
-    />
-
-    <OverlayText
-     position  = "0.1733, 0.038"
-     pickpoint = "0.0, 0.0"
-     font      = "ShareTechMono"
-     textsize  = 0.04
-     colour    = "1.0, 1.0, 1.0, 1.0"
-     align     = "left"
-     caption   = "|"
-    />
-
   </OverlayGroup>
 </Template>