Index: /code/branches/usability/data/gui/configs/CEGUIConfig.xsd
===================================================================
--- /code/branches/usability/data/gui/configs/CEGUIConfig.xsd	(revision 7915)
+++ /code/branches/usability/data/gui/configs/CEGUIConfig.xsd	(revision 7916)
@@ -2,5 +2,5 @@
 <xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema" elementFormDefault="qualified">
 
-	<xsd:element name="CEGUIConfig" type="CEGUIConfigType"/>
+    <xsd:element name="CEGUIConfig" type="CEGUIConfigType"/>
 
     <xsd:simpleType name="LogLevel">
@@ -12,16 +12,16 @@
         </xsd:restriction>
     </xsd:simpleType>
-    
-	<xsd:complexType name="CEGUIConfigType">
-		<xsd:attribute name="Logfile" type="xsd:string" use="optional" default=""/>
-		<xsd:attribute name="Scheme" type="xsd:string" use="optional" default=""/>
-		<xsd:attribute name="DefaultFont" type="xsd:string" use="optional" default=""/>
-		<xsd:attribute name="Layout" type="xsd:string" use="optional" default=""/>
-		<xsd:attribute name="InitScript" type="xsd:string" use="optional" default=""/>
-		<xsd:attribute name="TerminateScript" type="xsd:string" use="optional" default=""/>
-		<xsd:attribute name="DefaultResourceGroup" type="xsd:string" use="optional"  default="" />
+
+    <xsd:complexType name="CEGUIConfigType">
+        <xsd:attribute name="Logfile" type="xsd:string" use="optional" default=""/>
+        <xsd:attribute name="Scheme" type="xsd:string" use="optional" default=""/>
+        <xsd:attribute name="DefaultFont" type="xsd:string" use="optional" default=""/>
+        <xsd:attribute name="Layout" type="xsd:string" use="optional" default=""/>
+        <xsd:attribute name="InitScript" type="xsd:string" use="optional" default=""/>
+        <xsd:attribute name="TerminateScript" type="xsd:string" use="optional" default=""/>
+        <xsd:attribute name="DefaultResourceGroup" type="xsd:string" use="optional"  default="" />
         <xsd:attribute name="LoggingLevel" type="LogLevel" use="optional"  default="Standard" />
-	</xsd:complexType>
-	
+    </xsd:complexType>
+
 </xsd:schema>
 
Index: /code/branches/usability/data/gui/schemes/GUIScheme.xsd
===================================================================
--- /code/branches/usability/data/gui/schemes/GUIScheme.xsd	(revision 7915)
+++ /code/branches/usability/data/gui/schemes/GUIScheme.xsd	(revision 7916)
@@ -1,53 +1,53 @@
 <?xml version="1.0" ?>
 <xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema" elementFormDefault="qualified">
-	<xsd:element name="GUIScheme" type="SchemeType" />
-	<xsd:complexType name="SchemeType">
+    <xsd:element name="GUIScheme" type="SchemeType" />
+    <xsd:complexType name="SchemeType">
         <xsd:choice minOccurs="0" maxOccurs="unbounded">
-			<xsd:element name="Imageset" type="NamedDataType" />
+            <xsd:element name="Imageset" type="NamedDataType" />
             <xsd:element name="ImagesetFromImage" type="NamedDataType" />
-			<xsd:element name="Font" type="NamedDataType" />
+            <xsd:element name="Font" type="NamedDataType" />
             <xsd:element name="LookNFeel" type="FileDataType" />
-			<xsd:element name="WindowSet" type="WindowSetType" />
-			<xsd:element name="WindowRendererSet" type="WindowRendererSetType" />
-			<xsd:element name="WindowAlias" type="WindowAliasType" />
+            <xsd:element name="WindowSet" type="WindowSetType" />
+            <xsd:element name="WindowRendererSet" type="WindowRendererSetType" />
+            <xsd:element name="WindowAlias" type="WindowAliasType" />
             <xsd:element name="FalagardMapping" type="FalagardMapType" />
-		</xsd:choice>
-		<xsd:attribute name="Name" type="xsd:string" use="required" />
-	</xsd:complexType>
-	<xsd:complexType name="WindowSetType">
-		<xsd:sequence>
+        </xsd:choice>
+        <xsd:attribute name="Name" type="xsd:string" use="required" />
+    </xsd:complexType>
+    <xsd:complexType name="WindowSetType">
+        <xsd:sequence>
             <xsd:element name="WindowFactory" type="WindowFactoryType" minOccurs="0" maxOccurs="unbounded" />
-		</xsd:sequence>
-		<xsd:attribute name="Filename" type="xsd:string" use="required" />
-	</xsd:complexType>
-	<xsd:complexType name="WindowRendererSetType">
-		<xsd:sequence>
+        </xsd:sequence>
+        <xsd:attribute name="Filename" type="xsd:string" use="required" />
+    </xsd:complexType>
+    <xsd:complexType name="WindowRendererSetType">
+        <xsd:sequence>
             <xsd:element name="WindowRendererFactory" type="WindowRendererFactoryType" minOccurs="0" maxOccurs="unbounded" />
-		</xsd:sequence>
-		<xsd:attribute name="Filename" type="xsd:string" use="required" />
-	</xsd:complexType>
+        </xsd:sequence>
+        <xsd:attribute name="Filename" type="xsd:string" use="required" />
+    </xsd:complexType>
     <xsd:complexType name="FileDataType">
         <xsd:attribute name="Filename" type="xsd:string" use="required" />
         <xsd:attribute name="ResourceGroup" type="xsd:string" use="optional"  default="" />
     </xsd:complexType>
-	<xsd:complexType name="NamedDataType">
-		<xsd:attribute name="Name" type="xsd:string" use="required" />
-		<xsd:attribute name="Filename" type="xsd:string" use="required" />
-		<xsd:attribute name="ResourceGroup" type="xsd:string" use="optional"  default="" />
-	</xsd:complexType>
-	<xsd:complexType name="WindowFactoryType">
-		<xsd:attribute name="Name" type="xsd:string" use="required" />
-	</xsd:complexType>
-	<xsd:complexType name="WindowRendererFactoryType">
-		<xsd:attribute name="Name" type="xsd:string" use="required" />
-	</xsd:complexType>
-	<xsd:complexType name="WindowAliasType">
-		<xsd:attribute name="Alias" type="xsd:string" use="required" />
-		<xsd:attribute name="Target" type="xsd:string" use="required" />
-	</xsd:complexType>
+    <xsd:complexType name="NamedDataType">
+        <xsd:attribute name="Name" type="xsd:string" use="required" />
+        <xsd:attribute name="Filename" type="xsd:string" use="required" />
+        <xsd:attribute name="ResourceGroup" type="xsd:string" use="optional"  default="" />
+    </xsd:complexType>
+    <xsd:complexType name="WindowFactoryType">
+        <xsd:attribute name="Name" type="xsd:string" use="required" />
+    </xsd:complexType>
+    <xsd:complexType name="WindowRendererFactoryType">
+        <xsd:attribute name="Name" type="xsd:string" use="required" />
+    </xsd:complexType>
+    <xsd:complexType name="WindowAliasType">
+        <xsd:attribute name="Alias" type="xsd:string" use="required" />
+        <xsd:attribute name="Target" type="xsd:string" use="required" />
+    </xsd:complexType>
     <xsd:complexType name="FalagardMapType">
         <xsd:attribute name="WindowType" type="xsd:string" use="required" />
         <xsd:attribute name="TargetType" type="xsd:string" use="required" />
-		<xsd:attribute name="Renderer" type="xsd:string" use="required" />
+        <xsd:attribute name="Renderer" type="xsd:string" use="required" />
         <xsd:attribute name="LookNFeel" type="xsd:string" use="required" />
     </xsd:complexType>
Index: /code/branches/usability/data/gui/schemes/OrxonoxLook.scheme
===================================================================
--- /code/branches/usability/data/gui/schemes/OrxonoxLook.scheme	(revision 7915)
+++ /code/branches/usability/data/gui/schemes/OrxonoxLook.scheme	(revision 7916)
@@ -1,7 +1,7 @@
 <?xml version="1.0" ?>
 <GUIScheme Name="OrxonoxLook">
-	<Imageset Name="OrxonoxLook" Filename="OrxonoxLook.imageset" />
-	<LookNFeel Filename="OrxonoxLook.looknfeel" />
-	<WindowRendererSet Filename="CEGUIFalagardWRBase" />
+    <Imageset Name="OrxonoxLook" Filename="OrxonoxLook.imageset" />
+    <LookNFeel Filename="OrxonoxLook.looknfeel" />
+    <WindowRendererSet Filename="CEGUIFalagardWRBase" />
 
     <!-- Standard widgets -->
@@ -45,5 +45,5 @@
     <FalagardMapping WindowType="OrxonoxLook/Tooltip"                  TargetType="CEGUI/Tooltip"           Renderer="Falagard/Tooltip"           LookNFeel="OrxonoxLook/Tooltip" />
     <FalagardMapping WindowType="OrxonoxLook/Tree"                     TargetType="CEGUI/Tree"              Renderer="Falagard/Tree"              LookNFeel="OrxonoxLook/Tree" />
-    
+
     <!-- Additional widgets -->
     <FalagardMapping WindowType="OrxonoxLook/AlternateProgressBar"        TargetType="CEGUI/ProgressBar"       Renderer="Falagard/ProgressBar"       LookNFeel="OrxonoxLook/AltProgressBar" />
Index: /code/branches/usability/data/gui/schemes/TaharezGreenLook.scheme
===================================================================
--- /code/branches/usability/data/gui/schemes/TaharezGreenLook.scheme	(revision 7915)
+++ /code/branches/usability/data/gui/schemes/TaharezGreenLook.scheme	(revision 7916)
@@ -1,7 +1,7 @@
 <?xml version="1.0" ?>
 <GUIScheme Name="TaharezGreenLook">
-	<Imageset Name="TaharezGreenLook" Filename="TaharezGreenLook.imageset" />
-	<LookNFeel Filename="TaharezGreenLook.looknfeel" />
-	<WindowRendererSet Filename="CEGUIFalagardWRBase" />
+    <Imageset Name="TaharezGreenLook" Filename="TaharezGreenLook.imageset" />
+    <LookNFeel Filename="TaharezGreenLook.looknfeel" />
+    <WindowRendererSet Filename="CEGUIFalagardWRBase" />
 
     <!-- Standard widgets -->
@@ -45,5 +45,5 @@
     <FalagardMapping WindowType="TaharezGreenLook/Tooltip"                  TargetType="CEGUI/Tooltip"           Renderer="Falagard/Tooltip"           LookNFeel="TaharezGreenLook/Tooltip" />
     <FalagardMapping WindowType="TaharezGreenLook/Tree"                     TargetType="CEGUI/Tree"              Renderer="Falagard/Tree"              LookNFeel="TaharezGreenLook/Tree" />
-    
+
     <!-- Additional widgets -->
     <FalagardMapping WindowType="TaharezGreenLook/AlternateProgressBar"        TargetType="CEGUI/ProgressBar"       Renderer="Falagard/ProgressBar"       LookNFeel="TaharezGreenLook/AltProgressBar" />
Index: /code/branches/usability/data/gui/schemes/TaharezLook.scheme
===================================================================
--- /code/branches/usability/data/gui/schemes/TaharezLook.scheme	(revision 7915)
+++ /code/branches/usability/data/gui/schemes/TaharezLook.scheme	(revision 7916)
@@ -1,7 +1,7 @@
 <?xml version="1.0" ?>
 <GUIScheme Name="TaharezLook">
-	<Imageset Name="TaharezLook" Filename="TaharezLook.imageset" />
-	<LookNFeel Filename="TaharezLook.looknfeel" />
-	<WindowRendererSet Filename="CEGUIFalagardWRBase" />
+    <Imageset Name="TaharezLook" Filename="TaharezLook.imageset" />
+    <LookNFeel Filename="TaharezLook.looknfeel" />
+    <WindowRendererSet Filename="CEGUIFalagardWRBase" />
 
     <!-- Standard widgets -->
@@ -45,5 +45,5 @@
     <FalagardMapping WindowType="TaharezLook/Tooltip"                  TargetType="CEGUI/Tooltip"           Renderer="Falagard/Tooltip"           LookNFeel="TaharezLook/Tooltip" />
     <FalagardMapping WindowType="TaharezLook/Tree"                     TargetType="CEGUI/Tree"              Renderer="Falagard/Tree"              LookNFeel="TaharezLook/Tree" />
-    
+
     <!-- Additional widgets -->
     <FalagardMapping WindowType="TaharezLook/AlternateProgressBar"        TargetType="CEGUI/ProgressBar"       Renderer="Falagard/ProgressBar"       LookNFeel="TaharezLook/AltProgressBar" />
Index: /code/branches/usability/data/gui/scripts/MultiplayerMenu.lua
===================================================================
--- /code/branches/usability/data/gui/scripts/MultiplayerMenu.lua	(revision 7915)
+++ /code/branches/usability/data/gui/scripts/MultiplayerMenu.lua	(revision 7916)
@@ -10,5 +10,5 @@
 
 function P.onLoad()
-    P.multiplayerMode = "startClient" 
+    P.multiplayerMode = "startClient"
 
     --button are arranged in a 2x2 matrix, the left lower item is nil
@@ -38,5 +38,5 @@
     P.oldindex = -2
     P.index = -1
-    
+
     if P.joinMode == 1 then
         local window = winMgr:getWindow("orxonox/MultiplayerLanButton")
@@ -56,5 +56,5 @@
     P.joinMode = 1
     if button:isSelected() == true then
-	    P.showServerList()
+        P.showServerList()
     end
 end
@@ -65,6 +65,6 @@
     P.joinMode = 2
     if button:isSelected() == true then
-	    P.showServerList()
-	end
+        P.showServerList()
+    end
 end
 
@@ -92,71 +92,71 @@
 
 function P.showServerList()
-	-- LAN Discovery
-	if P.joinMode == 1 then
-		local listbox = winMgr:getWindow("orxonox/MultiplayerListbox")
-		CEGUI.toListbox(listbox):resetList()
-		local discovery = orxonox.LANDiscovery:getInstance()
-		discovery:discover()
-		P.serverList = {}
-		local index = 0
-		local servername = ""
-		local serverip = ""
-		while true do
-		    servername = discovery:getServerListItemName(index)
-		    if servername == "" then
-		        break
-		    end
-		    serverip = discovery:getServerListItemIP(index)
-		    if serverip == "" then
-		      break
-		    end
-		    table.insert(P.serverList, {servername, serverip})
-		    index = index + 1
-		end
-		index = 1
-		for k,v in pairs(P.serverList) do
-		    local item = CEGUI.createListboxTextItem( v[1] .. ": " .. v[2] )
-		    item:setID(index)
-		    index = index + 1
-		    item:setSelectionBrushImage(menuImageSet, "MultiListSelectionBrush")
-		    CEGUI.toListbox(listbox):addItem(item)
-		end
-	-- WAN Discovery
-	elseif P.joinMode == 2 then
-		local listbox = winMgr:getWindow("orxonox/MultiplayerListbox")
-		CEGUI.toListbox(listbox):resetList()
-		local discovery = orxonox.WANDiscovery:getInstance()
-		cout(0, "discovering.\n" )
-		discovery:discover()
-		cout(0, "discovered.\n" )
-		P.serverList = {}
-		local index = 0
-		local servername = ""
-		local serverip = ""
-		while true do
-		    servername = discovery:getServerListItemName(index)
-		    if servername == "" then
-		        break
-		    end
-		    serverip = discovery:getServerListItemIP(index)
-		    if serverip == "" then
-		      break
-		    end
-		    table.insert(P.serverList, {servername, serverip})
-		    index = index + 1
-		end
-		index = 1
-		for k,v in pairs(P.serverList) do
-		    local item = CEGUI.createListboxTextItem( v[1] .. ": " .. v[2] )
-		    item:setID(index)
-		    index = index + 1
-		    item:setSelectionBrushImage(menuImageSet, "MultiListSelectionBrush")
-		    CEGUI.toListbox(listbox):addItem(item)
-		end
-	end
-	
+    -- LAN Discovery
+    if P.joinMode == 1 then
+        local listbox = winMgr:getWindow("orxonox/MultiplayerListbox")
+        CEGUI.toListbox(listbox):resetList()
+        local discovery = orxonox.LANDiscovery:getInstance()
+        discovery:discover()
+        P.serverList = {}
+        local index = 0
+        local servername = ""
+        local serverip = ""
+        while true do
+            servername = discovery:getServerListItemName(index)
+            if servername == "" then
+                break
+            end
+            serverip = discovery:getServerListItemIP(index)
+            if serverip == "" then
+                break
+            end
+            table.insert(P.serverList, {servername, serverip})
+            index = index + 1
+        end
+        index = 1
+        for k,v in pairs(P.serverList) do
+            local item = CEGUI.createListboxTextItem( v[1] .. ": " .. v[2] )
+            item:setID(index)
+            index = index + 1
+            item:setSelectionBrushImage(menuImageSet, "MultiListSelectionBrush")
+            CEGUI.toListbox(listbox):addItem(item)
+        end
+    -- WAN Discovery
+    elseif P.joinMode == 2 then
+        local listbox = winMgr:getWindow("orxonox/MultiplayerListbox")
+        CEGUI.toListbox(listbox):resetList()
+        local discovery = orxonox.WANDiscovery:getInstance()
+        cout(0, "discovering.\n" )
+        discovery:discover()
+        cout(0, "discovered.\n" )
+        P.serverList = {}
+        local index = 0
+        local servername = ""
+        local serverip = ""
+        while true do
+            servername = discovery:getServerListItemName(index)
+            if servername == "" then
+                break
+            end
+            serverip = discovery:getServerListItemIP(index)
+            if serverip == "" then
+                break
+            end
+            table.insert(P.serverList, {servername, serverip})
+            index = index + 1
+        end
+        index = 1
+        for k,v in pairs(P.serverList) do
+            local item = CEGUI.createListboxTextItem( v[1] .. ": " .. v[2] )
+            item:setID(index)
+            index = index + 1
+            item:setSelectionBrushImage(menuImageSet, "MultiListSelectionBrush")
+            CEGUI.toListbox(listbox):addItem(item)
+        end
+    end
+
 end
 
-function P.onKeyPressed() 
+function P.onKeyPressed()
     buttonIteratorHelper(P.buttonList, code, P, 2, 2)
 end