Index: branches/gui/src/lib/gui/gl_gui/Makefile.am
===================================================================
--- branches/gui/src/lib/gui/gl_gui/Makefile.am	(revision 7915)
+++ branches/gui/src/lib/gui/gl_gui/Makefile.am	(revision 7917)
@@ -33,4 +33,5 @@
 		signal_connector.h \
 		glgui.h \
+		glgui_defs.h \
 		glgui_handler.h \
 		glgui_mainwidget.h \
Index: branches/gui/src/lib/gui/gl_gui/glgui.h
===================================================================
--- branches/gui/src/lib/gui/gl_gui/glgui.h	(revision 7915)
+++ branches/gui/src/lib/gui/gl_gui/glgui.h	(revision 7917)
@@ -21,13 +21,4 @@
 #include "glgui_textfield.h"
 
-namespace OrxGui
-{
-
-
-};
-
-
-
-
 
 #endif /* _GLGUI_H */
Index: branches/gui/src/lib/gui/gl_gui/glgui_bar.cc
===================================================================
--- branches/gui/src/lib/gui/gl_gui/glgui_bar.cc	(revision 7915)
+++ branches/gui/src/lib/gui/gl_gui/glgui_bar.cc	(revision 7917)
@@ -46,5 +46,5 @@
     this->setClassID(CL_GLGUI_BAR, "GLGuiBar");
 
-    this->frontMat.setDiffuse(1,1,1);
+    this->frontMaterial().setDiffuse(1,1,1);
 
     this->setSize2D(50, 10);
@@ -64,5 +64,5 @@
     GLGuiWidget::draw();
 
-    this->frontMat.select();
+    this->frontMaterial().select();
     glBegin(GL_QUADS);
 
Index: branches/gui/src/lib/gui/gl_gui/glgui_defs.h
===================================================================
--- branches/gui/src/lib/gui/gl_gui/glgui_defs.h	(revision 7917)
+++ branches/gui/src/lib/gui/gl_gui/glgui_defs.h	(revision 7917)
@@ -0,0 +1,20 @@
+/*!
+ * @file glgui_defs.h
+ * Definitions for the GLGui.
+ */
+
+#ifndef _GLGUI_DEFS_H
+#define _GLGUI_DEFS_H
+
+/// TODO MOVE TO ORXGUI_TYPES
+namespace OrxGui
+{
+  //! An enumeration for the Orientation of an Element.
+  typedef enum {
+    Horizontal,    //!< Horizontal Orientation.
+    Vertical       //!< Vertical Orientation.
+  } Orientation;
+};
+
+
+#endif /* _GLGUI_DEFS_H */
Index: branches/gui/src/lib/gui/gl_gui/glgui_slider.h
===================================================================
--- branches/gui/src/lib/gui/gl_gui/glgui_slider.h	(revision 7915)
+++ branches/gui/src/lib/gui/gl_gui/glgui_slider.h	(revision 7917)
@@ -9,5 +9,5 @@
 
 #include "glgui_widget.h"
-
+#include "glgui_defs.h"
 
 namespace OrxGui
@@ -31,4 +31,10 @@
 
   private:
+    Orientation      orientation;
+
+    float            _maxValue;
+    float            _minValue;
+
+    float            _value;
 
   };
Index: branches/gui/src/lib/gui/gl_gui/glgui_widget.cc
===================================================================
--- branches/gui/src/lib/gui/gl_gui/glgui_widget.cc	(revision 7915)
+++ branches/gui/src/lib/gui/gl_gui/glgui_widget.cc	(revision 7917)
@@ -65,8 +65,4 @@
     this->backMat.setDiffuse(1.0, 1.0, 1.0);
     this->frontMat.setDiffuse(1.0, 0.0, 0.0);
-
-    this->frontModel = 0;
-    this->backModel = 0;
-
 
     this->widgetSignals.resize(SignalCount, SignalConnector());
Index: branches/gui/src/lib/gui/gl_gui/glgui_widget.h
===================================================================
--- branches/gui/src/lib/gui/gl_gui/glgui_widget.h	(revision 7915)
+++ branches/gui/src/lib/gui/gl_gui/glgui_widget.h	(revision 7917)
@@ -8,9 +8,13 @@
 
 #include "element_2d.h"
-#include "event.h"
+#include "rect2D.h"
+
 #include "material.h"
 
+#include "event.h"
+#include "signal_connector.h"
+
 #include "glincl.h"
-#include "signal_connector.h"
+
 #include <vector>
 
@@ -117,14 +121,17 @@
 
 
-  protected:
+  private:
+    /// LOOKS
     Material                       backMat;
-    GLuint                         backModel;
+    Rect2D                         backRect;
 
     Material                       frontMat;
-    GLuint                         frontModel;
+    Rect2D                         frontRect;
 
-  private:
+
+    /// SIGNALS
     std::vector<SignalConnector>   widgetSignals;
 
+    /// EVENTS
     bool                           _focusable;        //!< If this widget can receive focus.
     bool                           _clickable;        //!< if this widget can be clicked upon.
Index: branches/gui/src/lib/math/rect2D.h
===================================================================
--- branches/gui/src/lib/math/rect2D.h	(revision 7915)
+++ branches/gui/src/lib/math/rect2D.h	(revision 7917)
@@ -24,5 +24,4 @@
 #define __RECT2D_H_
 
-#include <cmath>
 #include "vector2D.h"
 
@@ -34,4 +33,5 @@
 {
 public:
+  Rect2D() { };
   Rect2D(float x, float y, float width, float height);
   Rect2D(const Vector2D& topLeft, const Vector2D& bottomRight );
Index: branches/gui/src/lib/math/vector2D.h
===================================================================
--- branches/gui/src/lib/math/vector2D.h	(revision 7915)
+++ branches/gui/src/lib/math/vector2D.h	(revision 7917)
@@ -24,5 +24,5 @@
 #define __VECTOR2D_H_
 
-#include <math.h>
+#include <cmath>
 #include "compiler.h"
 